//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#ifndef ULM_WEATHERBALLOON_ULM_CCS811_H
#define ULM_WEATHERBALLOON_ULM_CCS811_H


#include "Adafruit_CCS811.h"
#include "Ulm_GenericSensor.h"

struct Ulm_CCS811_Sample {
    uint16_t co2;
    uint16_t tvoc;
};

class Ulm_CCS811 : public Adafruit_CCS811, public Ulm_GenericSensor<struct Ulm_CCS811_Sample> {

public:
    /**
     * Constructor.
     * @param address the i2c address of the CCS811 sensor.
     * @param wire the i2c interface.
     */
    Ulm_CCS811();

    /**
     * Inits the sensor and waits until it is ready.
     * @return {@code true} on success, {@code false} otherwise.
     */
    bool begin() override;

    bool sample(Ulm_CCS811_Sample &t) override;

};


#endif //ULM_WEATHERBALLOON_ULM_CCS811_H
